Decouple generation of docker image list from docker image prepull script
Signed-off-by: Zhe Huang <zhehuang@research.att.com>
Change-Id: I6bf494e3f8c88fd5f4d18c76699e9fddc08d963a
diff --git a/bin/gen-image-list b/bin/gen-image-list
new file mode 100755
index 0000000..30386af
--- /dev/null
+++ b/bin/gen-image-list
@@ -0,0 +1,91 @@
+#!/bin/bash
+##############################################################################
+#
+# Copyright (c) 2019 AT&T Intellectual Property.
+#
+# Licensed under the Apache License, Version 2.0 (the "License");
+# you may not use this file except in compliance with the License.
+# You may obtain a copy of the License at
+#
+# http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS,
+# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+# See the License for the specific language governing permissions and
+# limitations under the License.
+#
+##############################################################################
+
+# Installs well-known RIC charts then verifies specified helm chart
+# Requires chart tgz archives in /tmp
+
+
+while [ -n "$1" ]; do # while loop starts
+
+ case "$1" in
+
+ -f) OVERRIDEYAML=$2
+ shift
+ ;;
+ *) echo "Option $1 not recognized. Please use -f to specify the recipe path." ;; # In case you typed a different option other than a,b,c
+
+ esac
+
+ shift
+
+done
+
+if [ -z $OVERRIDEYAML ]; then
+ echo "Deploy recipe is missing. Please use -f to specify the recipe path."
+ exit 1
+fi
+
+
+ROOT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" >/dev/null && pwd )"
+TEMP_DIR=/tmp
+rm -rf $TEMP_DIR/imagelist
+touch $TEMP_DIR/imagelist
+CHART_ARRAY=()
+while IFS= read -r -d $'\0'; do
+ CHART_ARRAY+=("$REPLY")
+done < <(find $ROOT_DIR/../ -name Chart.yaml -printf '%h\0')
+
+rm -fr $TEMP_DIR/ric-common*.tgz
+
+helm package -d $TEMP_DIR $ROOT_DIR/../ric-common/Common-Template/helm/ric-common
+echo "***************************************"
+
+
+
+for dir in "${CHART_ARRAY[@]}"
+do
+
+ #rm -rf $dir/charts
+ rm -rf $dir/tmpcharts
+ echo "Analyzing Chart $(echo $dir | awk '{n=split($0, a, "/"); print a[n]}')"
+ echo $dir
+ mkdir -p $dir/charts
+ cp $TEMP_DIR/ric-common*.tgz $dir/charts/
+
+ helm dep up $dir > /dev/null 2>&1
+
+ IMAGE_ARRAY=$(helm template -f $OVERRIDEYAML $dir | grep "image:" | awk '{ gsub(/.*image: /, "", $0); gsub(/"/, "", $0); print $0}' )
+
+
+ for f in $IMAGE_ARRAY; do
+ if [ ! -z $f ]; then
+ FOUND=$(grep $f $TEMP_DIR/imagelist)
+ if [ -z $FOUND ]; then
+ echo "Found unique docker image $f."
+ echo $f >> $TEMP_DIR/imagelist
+ fi
+ fi
+ done
+
+ echo "***************************************"
+done
+
+
+
+echo "Your image list is available here: $TEMP_DIR/imagelist"